/*
  Exception handling
  Copyright (C) 1999  Hardy Kahl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ----------------------------------------------------------------------------
//  Description      : Exception handling
// ----------------------------------------------------------------------------
//  (c) Copyright 1996 by iXiONmedia, all rights reserved.
// ----------------------------------------------------------------------------




#include <stdio.h>
#include <string.h>
#include "exbase.h"




// Macros ---------------------------------------------------------------------
#define EX_INFOMAX 255




// Description forms ----------------------------------------------------------
#define T_DESCRIPTION1          "[%s%04X] %s"
#define T_DESCRIPTION2          "[%s%04X] %s <%s>"
#define T_DESCRIPTION3          "[%s%04X] %s <%s,%ld>"
#define T_DESCRIPTION1I         "[%s%04X] %s (%s)"
#define T_DESCRIPTION2I         "[%s%04X] %s (%s) <%s>"
#define T_DESCRIPTION3I         "[%s%04X] %s (%s) <%s,%ld>"




// xBaseException -------------------------------------------------------------
char xBaseException::Info[EX_INFOMAX+1];




xBaseException::xBaseException(TErrorCode error,char const *info,char *module,
  TIndexD line,char *category)
: Error(error),Module(module),Line(line),Category(category)
{
  HasInfo = (info!=NULL);
  if (info) {
    if (strlen(info)>EX_INFOMAX) {
      strncpy(Info,info,EX_INFOMAX);
      Info[EX_INFOMAX] = '\0';
    }
    else strcpy(Info,info);
  }
}




char *xBaseException::GetDescription(char *const stringbuffer) const
{
  if (HasInfo) {
    if (Module) {
      if (Line)
	sprintf(stringbuffer,T_DESCRIPTION3I,Category,Error,GetText(),Info,Module,Line);
      else
	sprintf(stringbuffer,T_DESCRIPTION2I,Category,Error,GetText(),Info,Module);
    }
    else
      sprintf(stringbuffer,T_DESCRIPTION1I,Category,Error,GetText(),Info);
  }
  else {
    if (Module) {
      if (Line)
	sprintf(stringbuffer,T_DESCRIPTION3,Category,Error,GetText(),Module,Line);
      else
	sprintf(stringbuffer,T_DESCRIPTION2,Category,Error,GetText(),Module);
    }
    else
      sprintf(stringbuffer,T_DESCRIPTION1,Category,Error,GetText());
  }
  return stringbuffer;
}
