/*
  Generic complex program definitions
  Copyright (C) 1999  Hardy Kahl

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ----------------------------------------------------------------------------
//  Description      : Generic complex program definitions.
// ----------------------------------------------------------------------------
//  Remarks          :
//    Hardy     18.11.1998      nobody should change this file, except the
//                              whole team decides.
// ----------------------------------------------------------------------------
//  Modifications    :
//    Hardy     18.11.1998      created this file.
// ----------------------------------------------------------------------------




#ifndef PRGCPLX_H
#define PRGCPLX_H




#include "prgbase.h"
#include "xstring.h"




// xPrograms : ----------------------------------------------------------------
class xComplexProgram : public xProgram<xString>
{
  public:
  xComplexProgram(void);

  virtual void Read(istream &stream);
  virtual void Write(ostream &stream);
};




inline istream &operator>>(istream &istr, xComplexProgram &prog)
{
  prog.Read(istr);
  return istr;
}




inline ostream &operator<<(ostream &ostr, xComplexProgram &prog)
{
  prog.Write(ostr);
  return ostr;
}




#endif
