/*
  plic prog
  Copyright (C) 1999  Achim Kern

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ---------------------------------------------------------------------------- 
//  Description      : Implementation of pli_prog.h 
// ---------------------------------------------------------------------------- 
//  Remarks          : 
// ---------------------------------------------------------------------------- 
//  Modifications    : 
//    Achim     15.04.1999      created. 
// ---------------------------------------------------------------------------- 




#include "pli_prog.h"




xPLI_Program::xPLI_Program()
{
  Indent = "";
};




void xPLI_Program::
add(xString String)
{
  (*this) += Indent + String;
};








void xPLI_Program::
attache(xString Str, TIndex LineNo)
{
  (*this)[LineNo] += Str;
};




void xPLI_Program::
attache(xString Str)
{
  attache(Str, get_CurrentLine());
};




void xPLI_Program::
add_Assign(xString left, EOperator op, xString firstop, xString secondop)
{
  switch (op)
  {
  case ADD:
    add(left + " := (" + firstop + " + " + secondop + ");");
    break;
  case SUB:
    add(left + " := (" + firstop + " - " + secondop + ");");
    break;
  default:;
  };
};




void xPLI_Program::
add_Assign(xString Left, xString Right)
{
  add(Left + " := " + Right + ";");;
};




void xPLI_Program::
add_While(xString Cond)
{
  add("while " + Cond + " do");
  add_Begin();
};




void xPLI_Program::add_If(xString Cond)
{
  add("if " + Cond + " then");
  add_Begin();
};




void xPLI_Program::add_Else()
{
  // delete ; in the last line of the program
  ((*this)[~(*this) - 1]).DeleteRightThis();
  add("else");
};




void xPLI_Program::add_For(xString counter, xString startval, xString endval)
{
  add("for " + counter + " := " + startval + " to " + endval + " do ");
  add_Begin();
};




void xPLI_Program::
add_Begin()
{
  add("begin");
  increaseIndent();
};




void xPLI_Program::
add_End()
{
  decreaseIndent();
  // delete ; in the last line of the program
  ((*this)[~(*this) - 1]).DeleteRightThis();
  add("end;");
};




void xPLI_Program::
add_EndofFunction()
{
  decreaseIndent();
  // delete ; in the last line of the program
  ((*this)[~(*this) - 1]).DeleteRightThis();
  add("end");
};




xString & xPLI_Program::
get_Argumentlist(xIdentifierList & Arguments, TIndex Size)
{
  xString *Arg = 0;

  Arg = new xString;
  
  if (~Arguments != 0)
  {
    *Arg = "(";
    for (TIndex i = 0; i < ~Arguments; i++)
    {
      *Arg += Arguments[i]->ResultAddress + ", ";
    };
    for (signed int i = (Size - (~Arguments)); i > 0; i--)
    {
      *Arg += "0, ";
    };
    Arg->DeleteThis(~(*Arg) - 2, 2);
    *Arg += ")";
  }
  else
  {
    *Arg ="()";
  };
  return *Arg;
};




xString & xPLI_Program::
get_Argumentlist(xExpressionList & Arguments, TIndex Size)
{
  xString *Arg = 0;

  Arg = new xString;

  *Arg = "(";
  for (TIndex i = 0; i < ~Arguments; i++)
  {
    *Arg += Arguments[i]->ResultAddress + ", ";
  };
  for (signed int i = (Size - (~Arguments)); i > 0; i--)
  {
    *Arg += "0, ";
  };
  Arg->DeleteThis(~(*Arg) - 2, 2);
  *Arg += ")";

  return *Arg;
};




TIndex xPLI_Program::
get_CurrentLine()
{
  return (~(*this) - 1);
};



void xPLI_Program::
increaseIndent()
{
  Indent += "  ";
};




void xPLI_Program::
decreaseIndent()
{
  Indent.DeleteThis(~Indent - 2, 2);
};
