/*
  plic prog
  Copyright (C) 1999  Achim Kern

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ---------------------------------------------------------------------------- 
//  Description      : Module for the purpose of compiling a parse tree 
// ---------------------------------------------------------------------------- 
//  Remarks          : 
// ---------------------------------------------------------------------------- 
//  Modifications    : 
//    Achim     15.04.1999      created. 
// ---------------------------------------------------------------------------- 




#ifndef PLIPROG_H
#define PLIPROG_H




#include "prgcplx.h"
#include "exbase.h"
#include "frontend.h"
#include "commontype.h"




enum EOperator
{
  ADD,
  SUB
};




class xPLI_Program : public xComplexProgram
{
 public:
  xPLI_Program();
  void add(xString String);                                 // adds a new line containing NewLine to the program
  void attache(xString String, TIndex LineNo);              // adds String to the contents of the programline LineNo
  void attache(xString String);                             // this function has the same effect as attache(String,get_CurrentLine());
  void add_While(xString Cond);                             // adds a new line with a while loop. Cond has to be just the name of a 
                                                            // variable as add_While inserts Cond + "#0".
  void add_If(xString Cond);
  void add_Else();
  void add_For(xString counter, xString startval, xString endval);
  void add_Assign(xString Left, xString Right);                             // adds a new line with left := right;
  void add_Assign(xString left, EOperator op, xString firstop, xString secondop);
  void add_Begin();                                                         // adds a new line with "begin"
  void add_End();                                                           // adds a new line with "end"
  void add_EndofFunction();
  xString & get_Argumentlist(xIdentifierList & Arguments, TIndex Size);              // attache (arg1,..,argn,0,...,0)
  xString & get_Argumentlist(xExpressionList & Arguments, TIndex Size);              // attache (arg1,..,argn,0,...,0)
  TIndex get_CurrentLine();
 private:
  xString Indent;
  void increaseIndent();
  void decreaseIndent();
};




#endif
