/*
  plic compiler - first pass
  Copyright (C) 1999  Achim Kern

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ---------------------------------------------------------------------------- 
//  Description      : Description of the backend of the Pascallicompiler 
// ---------------------------------------------------------------------------- 
//  Remarks          : 
// ---------------------------------------------------------------------------- 
//  Modifications    : 
//    Achim     03.06.1999      created. 
// ---------------------------------------------------------------------------- 




#ifndef BACKEND_1_H
#define BACKEND_1_H




#include "commontype.h"
#include "plic_Traverser.h"
#include "frontend.h"
#include "plic_MemManager1.h"




class xPascalliVisitor_firstpass : public xPascalliTraverser
{
 public:
  xPascalliVisitor_firstpass(); 
  ~xPascalliVisitor_firstpass();
  void visit_xFunctionCall(xFunctionCall & node);
  void visit_xForLoop(xForLoop & node);
  void visit_xWhile(xWhile & node);
  void visit_xAssignment(xAssignment & node);
 protected:
 private:
  TIndex        LastVarNr;
  xPLI_MemManager1  MemManager;
  TIndex            InsertedCommands;
};




#endif
