/*
  plic compiler - second pass
  Copyright (C) 1999  Achim Kern

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ---------------------------------------------------------------------------- 
//  Description      : Description of the backend of the Pascallicompiler 
// ---------------------------------------------------------------------------- 
//  Remarks          : 
// ---------------------------------------------------------------------------- 
//  Modifications    : 
//    Achim     03.06.1999      created. 
// ---------------------------------------------------------------------------- 




#ifndef BACKEND2_H
#define BACKEND2_H




#include "commontype.h"
#include "frontend.h"
#include "plic_Traverser.h"
#include "plic_MemManager2.h"




class xPascalliVisitor_secondpass:public xPascalliTraverser
{
 public:
  xPascalliVisitor_secondpass(TIndex lastcommand);
  ~xPascalliVisitor_secondpass();
  xNode* startCompilation(xNode * topnode);
  void visit_xProgramNode(xProgramNode & node);
  void visit_xFunction(xFunction & node);
  void visit_xAssignment(xAssignment & node);
  void visit_xWhile(xWhile & node);
  void visit_xIdentifier(xIdentifier & node);
  void visit_xArray(xArray & node);
  void visit_xFunctionCall(xFunctionCall & node);
 private:
  xProgramNode* TopNode;
  xPLI_MemManager2  MemManager;
  TIndex        LastCommand;
  EStatus       Status;
  ESide         Side;
};




#endif
