/*
  plic compiler - third pass
  Copyright (C) 1999  Achim Kern

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ---------------------------------------------------------------------------- 
//  Description      : Description of the backend of the Pascallicompiler 
// ---------------------------------------------------------------------------- 
//  Remarks          : 
// ---------------------------------------------------------------------------- 
//  Modifications    : 
//    Achim     03.06.1999      created. 
// ---------------------------------------------------------------------------- 




#ifndef BACKEND_3_H
#define BACKEND_3_H




#include "commontype.h"
#include "plic_MemManager3.h"
#include "frontend.h"
#include "plic_Traverser.h"




class xPascalliVisitor_thirdpass : public xPascalliTraverser
{
 public:
  xPascalliVisitor_thirdpass(); 
  ~xPascalliVisitor_thirdpass();
  
  void visit_xAssignment(xAssignment & node);
  void visit_xWhile(xWhile & node);
  void visit_xIfStatement(xIfStatement & node);
  void visit_xAddition(xAddition & node);
  void visit_xSubtraction(xSubtraction & node);
  void visit_xMultiplication(xMultiplication & node);
  void visit_xDivision(xDivision & node);
  void visit_xConstant(xConstant & node);
  void visit_xIdentifier(xIdentifier & node);
  void visit_xArray(xArray & node);
  void visit_xAnd(xAnd & node);
  void visit_xOr(xOr & node);
  void visit_xNot(xNot & node);
  void visit_xGreaterEqual(xGreaterEqual & node);
  void visit_xGreater(xGreater & node);
  void visit_xEqual(xEqual & node);
  void visit_xSmaller(xSmaller & node);
  void visit_xSmallerEqual(xSmallerEqual & node);
  void visit_xUnEqual(xUnEqual & node);
 protected:

 private:
  xPLI_MemManager3 MemManager;
  ESide        Side;
};




#endif
