/*
  plic memmanager
  Copyright (C) 1999  Achim Kern

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// ---------------------------------------------------------------------------- 
//  Description      : xMem_Manager is an object used by xPascalliVisitor. This
//                     Object keeps track of addresses of variables and 
//                     functions.
// ---------------------------------------------------------------------------- 
//  Remarks          : 
// ---------------------------------------------------------------------------- 
//  Modifications    : 
//    Achim     03.06.1999      created. 
//
// ---------------------------------------------------------------------------- 




#ifndef PLI_MEMMANAGER2_H
#define PLI_MEMMANAGER2_H



#include "commontype.h"
#include "xstring.h"
#include "frontend.h"



class xPLI_MemManager2
{
 public:
  xPLI_MemManager2(){};
  ~xPLI_MemManager2(){};
  void init(const xFunctionList & functions);
  TIndex getFunctionnumber(const xString & functionname);
  xVariable* New();
 private:
  xSymboltable Functionlist;
  xSymboltable Symboltable;
  xAddresslist FreeTmpVars;
  TIndex LastTmpVar;
};




#endif
