/*
  memory manager
  Copyright (C) 1999  Achim Kern

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "backend.h"
#include <iostream>
#include <fstream>
 


xMemoryManager::xMemoryManager()
{
  //  ofstream DebugFile("_Registers.log", ios::trunc);
};




/*

r0                                  baseaddress
             <-- managed by visitor | managed by memorymanager -->
|----------|------------------------|---------|------|---------------------|------|---------------------|
|parameters|4 regs. for internal use|variables|tmp[1]|array1[1]...arrayN[1]|tmp[2]|array1[2]...arrayN[2]|..........
|----------|------------------------|---------|------|---------------------|------|---------------------|

*/

void xMemoryManager::init(TIndex varno, TIndex offset, TIndex baseaddress)
{
  PageSize = offset + 1;
  LastUsedVarRegister = baseaddress - 1;
  LastUsedTmpRegister = baseaddress + varno;
  LastUsedArrayRegister = baseaddress + varno; 

  //  ofstream DebugFile("_Registers.log", ios::app);
  //  DebugFile << "number of variables: " << varno << endl; 
  //  DebugFile << "number of arrays: " << offset << endl;
};


void xMemoryManager::Free(TIndex RegisterNo)
{
  FreedTmpReg += RegisterNo;
};




TIndex xMemoryManager::GetAddress(xIdentifier& Node)
{

  if (Node.Address->Address == 0)
  {
    Node.Address->Address = new TIndex;
    switch (Node.Type)
    {
    case Simple:
      LastUsedVarRegister++;
      *(Node.Address->Address) = LastUsedVarRegister;
      break;
    case Array:
      LastUsedArrayRegister++;
      *(Node.Address->Address) = LastUsedArrayRegister;
      break;
    case Function:
      *(Node.Address->Address) = 0;
      break;
    default:
      // spaeter exeption handeln
      break;
    };
    // add debug info to log file
    //    ofstream DebugFile("_Registers.log", ios::app);
    //    DebugFile << Node.Name << " -> " << *(Node.Address->Address) << endl; 
  };
  return *(Node.Address->Address);
};




TIndex xMemoryManager::GetTmpReg()
{
  //  if (~FreedTmpReg == 0)
  // {
  //  LastUsedTmpRegister += PageSize + 1;
  //   cout << "  MemoryManager:  Temporaere Variable belegt bei R" << LastUsedTmpRegister << endl;
  //  return LastUsedTmpRegister;
  // }
  // else
  // {
  //  cout <<  "  MemoryManager:  Temporaere Variable belegt bei R" << FreedTmpReg[0] << endl;
  //  return FreedTmpReg[0];
  // }
  LastUsedTmpRegister += PageSize;
  return LastUsedTmpRegister;
};



